(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('angular-i18next')) :
    typeof define === 'function' && define.amd ? define('angular-validation-message', ['exports', '@angular/core', '@angular/forms', 'angular-i18next'], factory) :
    (global = global || self, factory(global['angular-validation-message'] = {}, global.ng.core, global.ng.forms, global.angularI18next));
}(this, function (exports, core, forms, angularI18next) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    var ValidationMessage = /** @class */ (function () {
        function ValidationMessage(key, params) {
            if (key === void 0) { key = ''; }
            if (params === void 0) { params = null; }
            this.key = '';
            this.key = key;
            this.params = params;
        }
        return ValidationMessage;
    }());

    var ValidationMessageComponent = /** @class */ (function () {
        function ValidationMessageComponent(formControlName, formGroupName) {
            this.formControlName = formControlName;
            this.for = null;
            this.acd = formControlName || formGroupName;
            if (this.acd != null)
                this.for = this.acd.control;
        }
        Object.defineProperty(ValidationMessageComponent.prototype, "standalone", {
            get: function () {
                return this.acd == null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ValidationMessageComponent.prototype, "messages", {
            get: function () {
                return this.getValidationMessages();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ValidationMessageComponent.prototype, "firstMessage", {
            get: function () {
                return this.messages[0] ? this.messages[0] : new ValidationMessage();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ValidationMessageComponent.prototype, "controlPath", {
            get: function () {
                if (this.acd == null)
                    return '';
                return this.acd.path.join('.');
            },
            enumerable: true,
            configurable: true
        });
        ValidationMessageComponent.prototype.getValidationMessages = function () {
            var _this = this;
            if (this.for == null || this.for.errors == null)
                return [];
            var messages = [];
            var keys = Object.keys(this.for.errors);
            keys.forEach(function (k) {
                var errValue = _this.for.errors[k];
                var params = null;
                if (errValue instanceof Object)
                    params = errValue;
                else if (errValue !== true) {
                    params = {};
                    params[k] = errValue;
                }
                messages.push(new ValidationMessage(k, params));
            });
            return messages;
        };
        __decorate([
            core.HostBinding('class.standalone'),
            __metadata("design:type", Boolean),
            __metadata("design:paramtypes", [])
        ], ValidationMessageComponent.prototype, "standalone", null);
        __decorate([
            core.Input(),
            __metadata("design:type", forms.AbstractControl)
        ], ValidationMessageComponent.prototype, "for", void 0);
        ValidationMessageComponent = __decorate([
            core.Component({
                selector: 'validation-message',
                template: "\n      <div class=\"error-container\">{{ firstMessage.key + (firstMessage.params ? '(' + firstMessage.params + ')' : '') }}</div>\n    ",
                encapsulation: core.ViewEncapsulation.None,
                styles: ["\n      validation-message {\n        display: none;\n        width: 100%;\n      }\n      validation-message.standalone,\n      .ng-dirty.ng-invalid + validation-message {\n        display: block;\n      }\n    "]
            }),
            __param(0, core.Optional()), __param(1, core.Optional()),
            __metadata("design:paramtypes", [forms.FormControlName, forms.FormGroupName])
        ], ValidationMessageComponent);
        return ValidationMessageComponent;
    }());

    var ValidationMessageDirective = /** @class */ (function () {
        function ValidationMessageDirective(viewContainer, componentFactoryResolver, vmComp) {
            this.viewContainer = viewContainer;
            this.componentFactoryResolver = componentFactoryResolver;
            this.vmComp = vmComp;
            this.validationMessageComponent = null;
        }
        ValidationMessageDirective.prototype.ngAfterViewInit = function () {
            var factory = this.componentFactoryResolver.resolveComponentFactory(this.vmComp);
            this.ngOnDestroy();
            this.validationMessageComponent = this.viewContainer.createComponent(factory, null, this.viewContainer.injector);
            this.validationMessageComponent.changeDetectorRef.detectChanges();
        };
        ValidationMessageDirective.prototype.ngOnDestroy = function () {
            if (this.validationMessageComponent) {
                this.validationMessageComponent.changeDetectorRef.detach();
            }
        };
        ValidationMessageDirective = __decorate([
            core.Directive({
                selector: '[validationMessage]'
            }),
            __param(2, core.Inject(ValidationMessageComponent)),
            __metadata("design:paramtypes", [core.ViewContainerRef,
                core.ComponentFactoryResolver,
                core.Type])
        ], ValidationMessageDirective);
        return ValidationMessageDirective;
    }());

    var ValidationError = /** @class */ (function () {
        function ValidationError() {
        }
        Object.defineProperty(ValidationError.prototype, "error", {
            get: function () {
                return this.control.getError(this.errorKey);
            },
            enumerable: true,
            configurable: true
        });
        return ValidationError;
    }());

    var ValidationErrorBuilder = /** @class */ (function () {
        function ValidationErrorBuilder() {
        }
        ValidationErrorBuilder.prototype.build = function (form, prevKey) {
            var validationErrors = [];
            var formControls = form.controls;
            for (var key in formControls) {
                if (formControls.hasOwnProperty(key)) {
                    var fullKey = prevKey ? [prevKey, key].join('.') : key;
                    var ctrl = formControls[key];
                    if (ctrl instanceof forms.FormControl) {
                        if (!ctrl.valid) {
                            for (var erKey in ctrl.errors) {
                                if (ctrl.errors.hasOwnProperty(erKey)) {
                                    var valError = new ValidationError();
                                    valError.control = ctrl;
                                    valError.controlKey = fullKey;
                                    valError.errorKey = erKey;
                                    validationErrors.push(valError);
                                }
                            }
                        }
                    }
                    else {
                        var group = ctrl;
                        validationErrors = validationErrors.concat(this.build(group, fullKey));
                    }
                }
            }
            return validationErrors;
        };
        return ValidationErrorBuilder;
    }());

    var declarations = [
        ValidationMessageDirective,
        ValidationMessageComponent,
    ];
    var ɵ0 = ValidationMessageComponent;
    var ValidationMessageModule = /** @class */ (function () {
        function ValidationMessageModule() {
        }
        ValidationMessageModule = __decorate([
            core.NgModule({
                declarations: declarations,
                exports: declarations,
                entryComponents: [
                    ValidationMessageComponent
                ],
                providers: [
                    ValidationErrorBuilder,
                    {
                        provide: ValidationMessageComponent,
                        useValue: ɵ0
                    }
                ]
            })
        ], ValidationMessageModule);
        return ValidationMessageModule;
    }());

    var I18NextValidationMessageComponent = /** @class */ (function (_super) {
        __extends(I18NextValidationMessageComponent, _super);
        function I18NextValidationMessageComponent(i18nextNamespace, formControlName, formGroupName) {
            var _this = _super.call(this, formControlName, formGroupName) || this;
            _this.i18nextNamespace = i18nextNamespace;
            _this.formControlName = formControlName;
            _this.formGroupName = formGroupName;
            _this.VALIDATION = 'validation';
            return _this;
        }
        Object.defineProperty(I18NextValidationMessageComponent.prototype, "i18nextKey", {
            get: function () {
                if (!this.firstMessage.key)
                    return '';
                var specificKey = [this.VALIDATION, ['control_specific', this.controlPath, this.firstMessage.key].join('.')].join(':');
                var commonKey = [this.VALIDATION, this.firstMessage.key].join(':');
                var i18nextKeys = [];
                if (this.i18nextNamespace && this.i18nextNamespace !== this.VALIDATION) {
                    i18nextKeys.push([this.i18nextNamespace, specificKey].join('.'));
                    i18nextKeys.push([this.i18nextNamespace, commonKey].join('.'));
                }
                i18nextKeys.push(specificKey);
                i18nextKeys.push(commonKey);
                return i18nextKeys;
            },
            enumerable: true,
            configurable: true
        });
        I18NextValidationMessageComponent = __decorate([
            core.Component({
                selector: 'i18next-validation-message',
                template: "\n      <div class=\"error-container\">{{ i18nextKey | i18nextCap: firstMessage.params }}</div>\n    ",
                encapsulation: core.ViewEncapsulation.None,
                styles: ["\n      i18next-validation-message {\n        display: none;\n        width: 100%;\n        position: relative;\n      }\n      i18next-validation-message.standalone,\n      .ng-dirty.ng-invalid + i18next-validation-message {\n        display: block;\n      }\n    "]
            }),
            __param(0, core.Inject(angularI18next.I18NEXT_NAMESPACE)),
            __param(1, core.Optional()),
            __param(2, core.Optional()),
            __metadata("design:paramtypes", [Object, forms.FormControlName,
                forms.FormGroupName])
        ], I18NextValidationMessageComponent);
        return I18NextValidationMessageComponent;
    }(ValidationMessageComponent));

    var declarations$1 = [
        I18NextValidationMessageComponent,
    ];
    var ɵ0$1 = I18NextValidationMessageComponent;
    var providers = [
        {
            provide: ValidationMessageComponent,
            useValue: ɵ0$1
        }
    ];
    var I18NextValidationMessageModule = /** @class */ (function () {
        function I18NextValidationMessageModule() {
        }
        I18NextValidationMessageModule = __decorate([
            core.NgModule({
                declarations: declarations$1,
                entryComponents: declarations$1,
                exports: [
                    declarations$1,
                    ValidationMessageModule
                ],
                imports: [
                    angularI18next.I18NextModule,
                    ValidationMessageModule
                ],
                providers: providers
            })
        ], I18NextValidationMessageModule);
        return I18NextValidationMessageModule;
    }());

    exports.I18NextValidationMessageModule = I18NextValidationMessageModule;
    exports.ValidationError = ValidationError;
    exports.ValidationErrorBuilder = ValidationErrorBuilder;
    exports.ValidationMessage = ValidationMessage;
    exports.ValidationMessageComponent = ValidationMessageComponent;
    exports.ValidationMessageDirective = ValidationMessageDirective;
    exports.ValidationMessageModule = ValidationMessageModule;
    exports.declarations = declarations;
    exports.providers = providers;
    exports.ɵ0 = ɵ0;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=angular-validation-message.umd.js.map
